Copyright (C) 2023 IPQualityScore LLC

# IPQualityScore SpamAssassin Plugin
This plugin allows IPQualityScore customers the opportunity to integrate our [email validation
API](https://www.ipqualityscore.com/documentation/email-validation/overview) with the popular open source spam
detection software [Apache SpamAssassin](https://spamassassin.apache.org/). For each message checked by SpamAssassin,
after the message has been parsed, the plugin sends an API request to IPQualityScore with the sender's email address
to be checked against IPQualityScore's real-time email reputation and validation system.

## Installation
Place the two files, IPQualityScore.pm and ipqualityscore.cf, into your site-wide SpamAssassin directory, e.g.
'/etc/mail/spamassassin'. Then add the following to your `init.pre`:
```
loadplugin IPQualityScore /path/to/IPQualityScore.pm
```
Edit the configuration file in ipqualityscore.cf to suit you. You must enter your IPQualityScore API key on the line
indicated in that file or the plugin will not work.

Finally, update the SpamAssassin matching patterns and compile them. This varies by platform. For example, if
SpamAssassin is running as the system user `spamd` and `sa-update` and `sa-compile` are located in
`/usr/bin/vendor_perl`, then you would run:
```
sudo -u spamd /usr/bin/vendor_perl/sa-update &&
sudo -u spamd /usr/bin/vendor_perl/sa-compile
```

## Configuration
Configuration occurs in `ipqualityscore.cf`, for which a detailed template with
defaults that will be reasonable for most users has been provided. Please review
that file and make changes to it to suit you. You must
include your unique API key on the line beginning `api_key`.

**WARNING:** Your API key is unique to you and should be treated like a password.

## Responses

In your final message REPORT/SUMMARY, there will be lines like the following:
```
 pts rule name              description
---- ---------------------- --------------------------------------------------
 1.0 IPQS_FRAUD_SCORE       ABCDEabcde IPQualityScore result [fraud_score: 95]
```
The 10-character string at the beginning of the description is the unique request identifier (request_id), which can
be used to lookup the request details or send a postback conversion notice. This value will also be present in the
header X-Spam-IPQS-Request-ID.

## Acknowledgments
[Michael Parker - Extending Apache SpamAssassin Using Plugins](http://people.apache.org/~parker/presentations/)
